
#include "brickreader.h"
//#include "brickmanager.h"
#include "vvdebugmsg.h"

#include <vector>

using namespace std;

BrickReader::~BrickReader()
{
  for(unsigned int i = 0; i <= fileDescList.size(); i++)
    if(mipmaps[i] != NULL)
      delete [] mipmaps[i];
} 

int BrickReader::init(int maxMipLevel, int brickSize, vector<FileInfo>& _fileDescList)
{
  vvDebugMsg::msg(2, "BrickReader::init()");

  assert(!_fileDescList.empty());

  fileDescList = vector<FileInfo>(_fileDescList);

  vvDebugMsg::msg(2, "origSizeX, origSizY, origSizeZ: ", fileDescList[0].sizeX, fileDescList[0].sizeY, fileDescList[0].sizeZ);
  
  mipmaps = new XVFVolume * [maxMipLevel+1];

  for(int i = 0; i <= maxMipLevel; i++) {
	vvDebugMsg::msg(2, "file name: ", fileDescList[i].name);
	mipmaps[i] = new XVFVolume(fileDescList[i].name);
	if(mipmaps[i]==NULL) {
	  vvDebugMsg::msg(1, "not enough memory, new failed?");
	  return -1;
	}
	mipmaps[i]->setBrickSize(brickSize);
  }

  vd = mipmaps[0]->getVolDesc();
  vd->frames = 0;

#if 0
  //vd = new vvVolDesc(fileDescList[0].name);

  vd->vox[0] = fileDescList[0].sizeX;
  vd->vox[1] = fileDescList[0].sizeY;
  vd->vox[2] = fileDescList[0].sizeZ;
  vd->frames = 0;

  vd->bpc = mipmaps[0]->getBytesPerChannel();
  vd->chan = mipmaps[0]->getNumChannel();
  /*
  vd->bpc = 1;
  vd->chan = 3;
  */
#endif

  return 0;
}

int BrickReader::getOneChannelData(int level, int x, int y, int z, int c, uchar* buf)
{
  // find the location of the data and read it
  //if ( mipmaps[level]->getOneChannelData( x, y, c, buf ) ==-1 ) return -1;
  return 0;
}

int BrickReader::getMultiChannelData(int level, int x, int y, int z, uchar* buf)
{
  if ( mipmaps[level]->getMultiChannelData( x, y, z, buf ) ==-1 ) return -1;
  return 0;
}

