#ifndef __VOLUME_H__
#define __VOLUME_H__

#include "vvvoldesc.h"

enum ShrinkMode{
        NEAREST = 0,
	BILINEAR
};

// file format parameter
enum VolOrganization {
	VOL_ORG_SEP = 0,	// saving all channels of one pixel separately
	VOL_ORG_MIX		// saving all channels of one pixel together ( as normal image format does/ readable by human eye )
};

class Volume {
public:
	Volume();
	virtual ~Volume();

	vvVolDesc* getVolDesc() { return vd; }
 
	virtual FILE *loadHeaders(char *filename) = 0;

	bool getOneChannelData(int x, int y, int z, int c, uchar *raw);
	bool getOneChannelData_sep(int x, int y, int z, int c, uchar *raw);
	bool getOneChannelData_mix(int x, int y, int z, int c, uchar *raw);

	bool getMultiChannelData(int x, int y, int z, uchar *raw);
	bool getMultiChannelData_sep(int x, int y, int z, uchar *raw);
	bool getMultiChannelData_mix(int x, int y, int z, uchar *raw);

	// volume properties
	int getBrickSize();
	void setBrickSize(int bS);
	unsigned int getVolOrganization() { return volOrganization; }
	void setVolOrganization(unsigned int volOrg);

	// Data source file related
	void closeFile() { if(fpVol != NULL) fclose(fpVol); }

public:
	vvVolDesc *vd;

	// volume properties
	int brickSize;
	int nBricks[3];
	int remaingPixels[3];
	int sliceBytes;
	int BPV;
	int volOrganization;

	// Data source file related
	FILE *fpVol;
	int whereData;

private:
	inline int round(float a) { return (a>0)? (int)(a+.5): (int)(a-.5); }
};

#endif
